/*
/////////////////////////////////
/////////// LUCYFERS  ///////////
/////////////////////////////////
//// lucyfers_fr@hotmail.com ////
/////////////////////////////////
*/


detectt()
{
        level._effect["wallexplosion"] = loadfx("fx/explosions/berlin_explosion.efx");
        level._effect["wallexplosion2"] = loadfx("fx/dirt/gib_break_dirt_3_6.efx");
        level._effect["wallexplosion3"] = loadfx("fx/dirt/dust_trail_100.efx");

        precacheModel("xmodel/explosivepack_objective");


	doors = getentarray("doorwl","targetname");
	if(isDefined(doors))
	{
		for(i=0;i<doors.size;i++)
		{
			doors[i] thread SetupDetect();
		}
	}
}


SetupDetect(door)
{
	TrigDoor = getent(self.target,"targetname");
	TrigDoor thread OpenDoor(85, self);
}


OpenDoor(angle, doorA)
{
	closed = 0;
        bomb = getent(self.target, "targetname");
	trigB = getent(bomb.target, "targetname");
        //coordonnes du script_model pour jouer le son d'explosion (sinon pb de son avec "originA"
        boum = getent(trigB.target,"targetname");
        doorafter = getent(boum.target, "targetname");

        bomb hide();   //la bombe est cache
        doorafter hide();

	while(1)
	{

                self waittill ("trigger", other);    //le Trigger attend qu'il soit dclancher par un joueur


		if((isPlayer(other)) && (other.pers["team"] == "axis"))   //si un des joueurs et que ce joueur est un allemand alors, on va la suite du programme (ligne suivante) sinon on va a l'tape suivante
		{
                       bombe = getent(self.target, "targetname");

		       wait(0.1);

		       if(other useButtonPressed())
		       {
                              if(closed == 0)
			      {
				     closed = 1;

                                     doorafter movez(-1000,0.2);      //suppression de la porte detruite de la map
                                     trigBomb = getent(bombe.target, "targetname");
                                     trigBomb movez(-1000,0.2);       //le trigger de la bombe est supprim pour viter que les axis posent la bombe

				     self triggerOff();   //trigger de la porte supprimer

				     doorA playsound("doors_wood_open");

				     doorA rotateto((0, angle, 0), 2, 0.5, 0.5);
				     doorA waittill("rotatedone");

				     doorA playsound("doors_wood_openstop");

				     self triggerOn();    //trigger de la porte remis
			      }
			      else
			      {
				     closed = 0;

                                     self triggerOff();

				     doorA playsound("doors_wood_closemove");

				     doorA rotateto((0, 0, 0), 2, 0.5, 0.5);
				     doorA waittill("rotatedone");

				     doorA playsound("doors_wood_closestop");
				     
                                     trigBomb = getent(bombe.target, "targetname");
                                     trigBomb movez(1000,0.2);       //trigger de la bombe remis
                                     doorafter movez(1000,0.2);      //la porte detruite est remis

				     self triggerOn();
			      }
		       }

		}
		else if((isPlayer(other)) && (other.pers["team"] == "allies"))   //si un des joueurs et que ce joueur est un alli alors, on va la suite du programme (ligne suivante)
		{
		        while(1)
		        {
		            wait(0.1);
		            if((closed == 0) && (other useButtonPressed()) && (other.pers["team"] == "allies"))
                            {
                                   bomb playsound("doors_wood_locked");
                                   break;
		            }
		            else if(closed == 1)
                            {
                                  break;
                            }

                        }

		        if(closed == 0)   //affectation d'une valeur pour dfinir que la porte est ferme
		        {
		                 wait(0.5);

                                 bomb show();   //la bombe est visible pour la poser

                                 //wait for someone on "allies" to use the trigger and plant bomb
                                 while (1)
                                 {
                                        stop=0;

                                        trigB waittill ("trigger",guy);

                                        if ((isplayer (guy)) && (guy.pers["team"] == "allies") && (guy useButtonPressed()))
                                        {
                                                bomb playsound ("MP_bomb_plant");
        
                                                //delete the trigger since it's no longer needed
                                                trigB triggerOff();

                                                guy disableWeapon();     //le joueur n'a plus d'arme pour poser la bombe

                                                up=0;
                                                while(1)
                                                {
                                                        wait(0.1);
                                                        if((isplayer (guy)) && (guy.pers["team"] == "allies") && (guy useButtonPressed()))
                                                        {
                                                                up=up+1;
                                                                if(up==30)    //3 secondes pour poser la bombe
                                                                {
                                                                      up=0;
                                                                      break;
                                                                }
                                                                else
                                                                {
                                                                      continue;  //la boucle est tjrs active
                                                                }

                                                        }
                                                        else
                                                        {
                                                                stop=1;
                                                                break;       //le joueur est soit mort ou bien il a lach la touche utiliser
                                                        }
                                                }
                                                wait(0.1);
                                                break;
                                        }
                                 }

                                 if(stop==1)
                                 {
                                            guy enableWeapon();      //le joueur a de nouveau son arme
                                            trigB triggerOn();      //l'explosif n'est pas amorc
                                            bomb hide();            //la bombe est de nouveau cach
                                            wait(2);
                                            continue;
                                 }
                                 else
                                 {
                                            guy enableWeapon();     //le joueur a de nouveau son arme

                                            //visualisation que la bombe est bien pos
                                            bomb setmodel ("xmodel/explosivepack_objective");

                                            wait (0.1);
 
                                            //son lorsque la bombe est plant
                                            bomb playsound("explo_plant_no_tick");

                                            wait(0.2);
                                            
                                            //son du tic-tac de la bombe
                                            bomb playLoopSound("bomb_tick");
 
                                            wait 10;     //attente de 10 secondes avant explosion
 
                                            //arrt du tic-tac de la bombe
                                            bomb stopLoopSound("bomb_tick");

                                            //relever des coordonnes de la bombe en mmoire
                                            originA = bomb getOrigin();

                                            //le model de la bombe est supprim du jeux
                                            bomb delete();

                                            //effet d'explosion de la bombe
                                            playfx(level._effect["wallexplosion"], originA);
                                            
                                            //son de l'explosion de la bombe
                                            boum playsound("bombe_doorB");

                                            //son de l'jection des morceaux de bois
                                            boum playsound("bombe_doorA");
                                            
                                            //show the broken version of the wall now and hide the old version
                                            doorafter show();

                                            //les portes sont supprimes
                                            doorA delete();

                                            doorafter playsound("doors_wood_open");
                                            doorafter rotateto((0, angle, 0), 0.4, 0.3, 0);

                                            wait(0.05);

                                            playfx(level._effect["wallexplosion2"], originA);

                                            //cause radius damage to kill people nearby
                                            radiusDamage(originA, 300, 1500, 500);

                                            wait(0.1);
                                            playfx(level._effect["wallexplosion3"], originA);

                                            break;

                                 }

                        }
                        else
                        {
                                 continue;
                        }

                        continue;

                }
	}
}

triggerOff()
{
	if (!isdefined (self.realOrigin))
		self.realOrigin = self.origin;

	if (self.origin == self.realOrigin)
		self.origin += (0, 0, -10000);
}

triggerOn()
{
	if (isDefined (self.realOrigin) )
		self.origin = self.realOrigin;
}
